
/* =========================================================
Beispielcode fr den Versand von SMS ber einen GET-Request
mit der WinINet-Bibliothek / MS Visual C++ 6.0
Aufruf von Kommandozeile
Autor: Joachim Nenning info@alphaQuest.de
fr www.sms4.de
===========================================================*/

#include "stdafx.h"
#include "urlencode.h"

using namespace std;


/* WICHTIG!
Vor dem Linken Einstellungen ndern unter:
Projekt - Einstellungen... - Alle Konfigurationen auswhlen -
im Reiter Linker unter Objekt-/Bibliothek-Module wininet.lib
hinzufgen und dann speichern
*/



//Internet Handles
HINTERNET hOpen;
HINTERNET hConnect;
HINTERNET hReq;

//URL
char url_escaped[4096];
char url_host_name[12];
char url_path[20];
char url_extra_info[4096];



/* Eine Liste mit den Dateitypen, die vom Server zurckgegeben werden drfen (Accept) */
LPCTSTR lpctstr[2] = { "text/html", NULL};

/* Variable zum Auslesen der Daten (128 bytes) */
char buffer[128];

/* SMS4 Parameter */
char handynr[16];
char user[61];
char pw[51];
char kdnr[31];
char *text_encoded;
char tarif[2];
char absender[23];

string text;


int main(int argc, char* argv[])
{

    if (argc < 6)
    {
     cerr << "Parameter: " << argv[0] <<" User Passwort Kundennr Handynr \"Text\" [Absender] [Tarif] " << endl;
	 return(1);
	}
	else {
		
		DWORD  dwSize, dwCode;

		strcpy(url_host_name, "www.sms4.de");
		strcpy(url_path, "/cgi-bin/sms_out.pl");

		//WinINet initialisieren
		hOpen = InternetOpen(
								"sms4",
								INTERNET_OPEN_TYPE_DIRECT,
								NULL,
								NULL,
								0
							); 

		//HTTP Verbindung ffnen
		hConnect = InternetConnect(
								hOpen,
								url_host_name,
								INTERNET_DEFAULT_HTTP_PORT,
								NULL,
								NULL,
								INTERNET_SERVICE_HTTP,
								0,
								0
							);

		//URL zusammenbauen
		strncpy(handynr, argv[4], sizeof(handynr));
		handynr[sizeof(handynr) - 1] = '\0';
		strcpy(url_extra_info, "?handynr=");
		strcat(url_extra_info, handynr);

		strncpy(user, argv[1], sizeof(user));
		user[sizeof(user) - 1] = '\0';
		strcat(url_extra_info, "&user=");
		strcat(url_extra_info, user);

		strncpy(pw, argv[2], sizeof(pw));
		pw[sizeof(pw) - 1] = '\0';
		strcat(url_extra_info, "&pwd=");
		strcat(url_extra_info, pw);

		strncpy(kdnr, argv[3], sizeof(kdnr));
		kdnr[sizeof(kdnr) - 1] = '\0';
		strcat(url_extra_info, "&kdnr=");
		strcat(url_extra_info, kdnr);

		/*
		Text der SMS urlencodieren
		Hinweis: die anderen Parameter	
		bei Bedarf auch encodieren)
		*/
		text = LPCTSTR(argv[5]);
		text = UrlEncodeString(text);
		text_encoded = new char [text.size()+1];
		strcpy (text_encoded, text.c_str());
		strcat(url_extra_info, "&text=");
		strcat(url_extra_info, text_encoded);

		if (argc >= 6)
		{
			if(argv[6]!=NULL)
			{
				strncpy(absender, argv[6], sizeof(absender));
				absender[sizeof(absender) - 1] = '\0';
				strcat(url_extra_info, "&absender=");
				strcat(url_extra_info, absender);
			}
		}

		if (argc >= 7)
		{
			if(argv[7]!=NULL)
			{
				strncpy(tarif, argv[7], sizeof(tarif));
				tarif[sizeof(tarif) - 1] = '\0';
				strcat(url_extra_info, "&tarif=");
				strcat(url_extra_info, tarif);
			}
		}

		url_extra_info[sizeof(url_extra_info) - 1] = '\0';
		
		strcat(url_escaped, url_path);
		strcat(url_escaped, url_extra_info);

		url_escaped[sizeof(url_escaped) - 1] = '\0';

		//HTTP Request via GET ffnen
		hReq = HttpOpenRequest(
								hConnect,
								"GET",
								url_escaped,
								NULL,
								NULL,
								lpctstr,
								INTERNET_FLAG_RELOAD | INTERNET_FLAG_NO_CACHE_WRITE,
								0
							);
		//Request senden
		HttpSendRequest(hReq, NULL, 0, NULL, 0);

		//HTTP Statuscodes einlesen
		dwSize = sizeof(DWORD);
		HttpQueryInfo(hReq, HTTP_QUERY_STATUS_CODE | HTTP_QUERY_FLAG_NUMBER, &dwCode, &dwSize, NULL);
		
		if(dwCode==200) {
			//Meldung ausgeben
			do 
			{ 
				InternetReadFile(hReq, &buffer, sizeof(buffer) - 1, &dwSize);
        
				if (! dwSize)
				{
					break;
				}
				else 
				{ 
					buffer[dwSize] = '\0';
					cout << buffer;
					cout << endl;
				}
			} 
			while (TRUE); 
		}
		else
			{
			cerr << "HTTP error ";
			if(dwCode!=	0) {
				cerr << dwCode;
			}
			cerr << endl;
		}

	
	//alle Handles schlieen
	InternetCloseHandle (hReq);
	InternetCloseHandle (hConnect);
	InternetCloseHandle (hOpen);
	
	}

	return(0);
}
